/*-
 * Copyright (C) @BABOLO  2002 Dec 08
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef lint
static const char copyright[] = "\
@(#)Copyright (C) @BABOLO  2002 Dec 08\n\
@(#)All rights reserved.\n";
static const char rcsid[] = "$Id: bufread.c,v 1.2 2002/12/14 01:00:39 babolo Exp $";
#endif /* not lint */

#include <sysexits.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include <err.h>
#include "binfout.h"

u_char *
bufread(FILE *fmt) {
    u_char *format;
    size_t i, j;

    if  ((format = malloc(j = BUFSIZE)) == NULL) {
        if  (v_flag >= 0) errx(EX_UNAVAILABLE, "Malloc failed #1\n");
        exit(EX_UNAVAILABLE);
    }
    for (i = 0; !feof(fmt) && !ferror(fmt);) {
        if  (i + 1 >= j && (format = realloc(format, j += BUFSIZE)) == NULL) {
            if  (v_flag >= 0) errx(EX_UNAVAILABLE, "Malloc failed #2\n");
            exit(EX_UNAVAILABLE);
        }
        if  (v_flag > 1) fprintf(stderr, "i=%d, j=%d\n", i, j);
        i += fread(&(format[i]), 1, j - i - 1, fmt);
        format[i] = '\0';
        if  (v_flag > 1) fprintf(stderr, "%s~\n", format);
    }
    if  (ferror(fmt)) {
        if  (v_flag >= 0) fprintf(stderr, "Input error\n");
        exit(EX_IOERR);
    }
    return(format);
}
